#ifndef __HMH__
#define __HMH__

#include <stdint.h>
#include <stdbool.h>

struct Hashmap;
typedef struct Hashmap Hashmap;

Hashmap *Hashmap_init();
void Hashmap_free(Hashmap *hm, void (*free_value)(void *));
void Hashmap_update(Hashmap *hm, uint32_t key, void *value);
bool Hashmap_contains(Hashmap *hm, uint32_t key);
void *Hashmap_get(Hashmap *hm, uint32_t key);
void Hashmap_delete(Hashmap *hm, uint32_t key);


#endif